package kck;

import java.awt.Dimension;
import java.awt.Toolkit;

import kck.gui.*;
import kck.logic.HTDData;

public class HTDView implements Runnable {
	public HTDData data;
	private MainWindow mw;
	
	public void run() {
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		
		data = new HTDData();
		mw = new MainWindow(this);
		
		mw.setDefaultCloseOperation(MainWindow.EXIT_ON_CLOSE);
    	mw.initComponents();
    	mw.initActions();
    	
    	mw.pack();
    	mw.setLocation((int)(dim.getWidth()*0.1), (int)(dim.getHeight()*0.1));
    	mw.setVisible(true);
	}
	
	public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new HTDView());
	}

}
