package src.visual;

import java.io.File;
import java.net.URL;

import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.UIManager;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;

import java.awt.image.BufferedImage;

import src.logical.Funkcja;
import src.logical.Profil;
import src.logical.Raport;

/*
 * Created on 26 padziernik 2005, 22:01
 */






/**
 *
 * @author  arTur
 */
public class Main_Frame extends JFrame {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private boolean lockSZoom = false;
	/** Creates new form NewFrame */
    public void NewFrame() {
        initComponents();
    }
    
    public Raport raport;
   
    private void initComponents() {
    		
    	try {
    		  UIManager.setLookAndFeel(
    		  UIManager.getSystemLookAndFeelClassName());
    		} catch (Exception e) {
    		}
    	
        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        PVizualization = new VisualizationPanel(this,VisualizationPanel.P_RGB);//new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        BProfile = new javax.swing.JButton();
        BFunction = new javax.swing.JButton();
        CBprofileLoaded = new javax.swing.JCheckBox();
        CBfunctionLoaded = new javax.swing.JCheckBox();
        SZoom = new javax.swing.JSlider();
        jPanel4 = new javax.swing.JPanel();
        RBBlackAndWhite = new javax.swing.JRadioButton();
        RBRgb = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        //BDraw = new javax.swing.JButton();
        BReport = new javax.swing.JButton();
        BSnapshot = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        raport = new Raport();
        skalakolorow = new JPanel() {
        	public void paintComponent(Graphics g)
        	{	super.paintComponent(g);
        		java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit(); 
            	Image im = tk.getImage(this.getClass().getResource("/colormap2.jpg"));
            	MediaTracker MedT = new MediaTracker(this);
        		MedT.addImage(im,0);
        		try {
        			MedT.waitForAll();
        		} catch (InterruptedException e) {
        			e.printStackTrace();
        		}
            	g.drawImage(im, 2, 2, Color.WHITE, null);
        	}
        };
        
        buttonGroup1.add(RBBlackAndWhite);
        buttonGroup1.add(RBRgb);

        setResizable(false);
        setTitle("StressVisualizator");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        PVizualization.setBackground(new java.awt.Color(255, 254, 254));
        PVizualization.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Load"));
        BProfile.setText("profile");

        BFunction.setText("function");

        CBprofileLoaded.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        CBprofileLoaded.setEnabled(false);
        CBprofileLoaded.setMargin(new java.awt.Insets(0, 0, 0, 0));

        CBfunctionLoaded.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        CBfunctionLoaded.setEnabled(false);
        CBfunctionLoaded.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, BProfile, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(BFunction, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(CBprofileLoaded)
                    .add(CBfunctionLoaded))
                .addContainerGap(53, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(BProfile)
                    .add(CBprofileLoaded))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(BFunction)
                    .add(CBfunctionLoaded)))
        );
        SZoom.setMaximum(100);
        SZoom.setMajorTickSpacing(10);
        SZoom.setMinorTickSpacing(5);
        SZoom.setOrientation(javax.swing.JSlider.VERTICAL);
        SZoom.setPaintTicks(true);
        SZoom.setValue(50);

        jPanel4.setLayout(new java.awt.GridLayout(2, 1));

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Palette"));
        RBBlackAndWhite.setText("levels");
        RBBlackAndWhite.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        RBBlackAndWhite.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel4.add(RBBlackAndWhite);

        RBRgb.setSelected(true);
        RBRgb.setText("stress");
        RBRgb.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        RBRgb.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel4.add(RBRgb);

       // jPanel5.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
      
        /*
        BDraw.setFont(new java.awt.Font("Tahoma", 1, 14));
        BDraw.setText("DRAW");
        BDraw.setEnabled(false);
        BDraw.setName("BDraw");*/

        skalakolorow.setName("skalakolorow");
        skalakolorow.setBorder(BorderFactory.createEtchedBorder());
        
        BReport.setText("Report...");
        BReport.setEnabled(false);

        BSnapshot.setText("Snapshot");
        BSnapshot.setEnabled(false);
        BSnapshot.setName("BSnapshot");
        
        SZoom.setEnabled(false);
        
        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                	.add(skalakolorow, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 80, Short.MAX_VALUE)
                   // .add(BDraw, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 80, Short.MAX_VALUE)
                    .add(BReport)
                    .add(BSnapshot))
                .addContainerGap())
        );
        
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5Layout.createSequentialGroup()
                .add(12, 12, 12)
                .add(skalakolorow, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 125, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
              //  .add(BDraw, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 50, Short.MAX_VALUE)
                .add(BSnapshot)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(BReport)
                .addContainerGap())
        );

        jLabel1.setText("min");

        jLabel2.setText("max");

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel3.setText("zoom");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(PVizualization, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 454, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jPanel5)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 106, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                                .add(SZoom, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel1)
                                    .add(jLabel2)))
                            .add(jLabel3)))
                    .add(jPanel3))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, PVizualization, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 445, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                                .add(14, 14, 14)
                                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel3)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                                        .add(jLabel2)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 309, Short.MAX_VALUE)
                                        .add(jLabel1))
                                    .add(SZoom, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 337, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))))
                .addContainerGap())
        );
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
        
        pack();
        
        
        
        
        PVizualization.init();
        
        
    }
    // </editor-fold>
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {                          
        System.exit(0);
    }     
    
    
    private void activateAll(){
    	if((funkcja!=null)&&(profil!=null)){
    	//	BDraw.setEnabled(true);
    		PVizualization.draw();
    		PVizualization.changes=true;
    		SZoom.setEnabled(true);
    		BReport.setEnabled(true);
    		BSnapshot.setEnabled(true);
    	}
	
    }
    
    
    private void initActions(){
    	BProfile.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				final JFileChooser fc = new JFileChooser();
				int returnVal;
				
				fc.setFileFilter(new FileFilter(){public boolean accept(File f){return f.isDirectory() || f.getName().endsWith(".txt");}; public String getDescription(){return "Dynamically linked library (*.txt)";};});
				
				returnVal = fc.showOpenDialog(Main_Frame.this);
				
				if (returnVal == JFileChooser.APPROVE_OPTION)
				{
					profil =new Profil();
					profil.load(fc.getSelectedFile().getAbsolutePath());
					PVizualization.setProfile(profil);
					if(funkcja!=null)funkcja.setProfil(profil);
					CBprofileLoaded.setSelected(true);
					activateAll();
				}
			}});
        
        BFunction.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				final JFileChooser fc = new JFileChooser();
				int returnVal;
				
				fc.setFileFilter(new FileFilter(){public boolean accept(File f){return f.isDirectory() || f.getName().endsWith(".dll");}; public String getDescription(){return "Dynamically linked library (*.dll)";};});
				
				returnVal = fc.showOpenDialog(Main_Frame.this);
				
				if (returnVal == JFileChooser.APPROVE_OPTION)
				{
					funkcja =new Funkcja(profil);
					funkcja.load(fc.getSelectedFile().getAbsolutePath());
					
					//funkcja =new src.logical.funkcja_ex(profil);
					
					PVizualization.setFunction(funkcja);
					CBfunctionLoaded.setSelected(true);
					
					
			
					activateAll();
				}
			}});
        	
        BSnapshot.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent arg0) {
        		String s = JOptionPane.showInputDialog(null, "Podaj opis snapshota", "Opis snapshota", JOptionPane.PLAIN_MESSAGE);
        		if (s != null)
        		{
        			BufferedImage img = new BufferedImage(PVizualization.getWidth(), PVizualization.getHeight(), BufferedImage.TYPE_INT_RGB);
        			img.getGraphics().drawImage(PVizualization.BufImgScreen.getScaledInstance(PVizualization.getWidth(), PVizualization.getHeight(), BufferedImage.SCALE_DEFAULT), 0, 0, null);
        			raport.addSnapshot(img, s);
        		}
        	}
        });
        
        BReport.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent arg0) {
        		final JFileChooser fc = new JFileChooser();
				int returnVal;
				
				fc.setFileFilter(new FileFilter(){public boolean accept(File f){return f.isDirectory() || f.getName().endsWith(".xml");}; public String getDescription(){return "XML Document (*.xml)";};});
				
				returnVal = fc.showSaveDialog(Main_Frame.this);
				
				if (returnVal == JFileChooser.APPROVE_OPTION)
				{
					File s = fc.getSelectedFile();
					if (! s.getName().endsWith(".xml"))
				    {
				    	s = new File(s.getAbsolutePath()+".xml");
				    }
					if ((s.exists() && (JOptionPane.showConfirmDialog(Main_Frame.this, "Plik o tej nazwie ju istnieje. Nadpisa?") == JOptionPane.OK_OPTION) || (! s.exists())))
					{
						raport.outputHTML(s);
						try {
							Runtime.getRuntime().exec("cmd /C start iexplore.exe "+s.getAbsolutePath());
						} catch (Exception e) {}
					}
				}
        		
        	}
        });
		
     /*   BDraw.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				PVizualization.draw();
			}});*/
		
        SZoom.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {			}

			public void mousePressed(MouseEvent arg0) {			}

			public void mouseReleased(MouseEvent arg0) {
				if(!lockSZoom)
					PVizualization.setMagnify((SZoom.getValue()-SZoom.getMaximum()/2)/(float)(SZoom.getMaximum()/2));
			}

			public void mouseEntered(MouseEvent arg0) {}

			public void mouseExited(MouseEvent arg0) {}
			});
        
        /*addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent arg0) {
				if(!lockSZoom)
				PVizualization.setMagnify((SZoom.getValue()-SZoom.getMaximum()/2)/(float)(SZoom.getMaximum()/2));
			}
        	
        });*/
        
       RBRgb.addActionListener(new ActionListener(){
    	   public void actionPerformed(ActionEvent arg0) {
			PVizualization.setPalette(VisualizationPanel.P_RGB);
		} 
       });
        
       RBBlackAndWhite.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent arg0) {
			PVizualization.setPalette(VisualizationPanel.P_BW);
		} 
          });
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	Main_Frame My_Frame = new Main_Frame();
            	//My_Frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            	My_Frame.initComponents();
            	My_Frame.initActions();
            	My_Frame.setVisible(true);
            }
        });
    }
    
    
    public void setZoomSlider(int value, int maxValue){
    	lockSZoom =true;
    	if(value>this.SZoom.getMaximum())value=this.SZoom.getMaximum();
    	this.SZoom.setValue(this.SZoom.getMaximum()/2+(value*this.SZoom.getMaximum()/2)/maxValue);
    	lockSZoom=false;
    }
    
    // Variables declaration - do not modify
    //private javax.swing.JButton BDraw;
    private javax.swing.JButton BFunction;
    private javax.swing.JButton BProfile;
    private javax.swing.JButton BReport;
    private javax.swing.JButton BSnapshot;
    private javax.swing.JCheckBox CBfunctionLoaded;
    private javax.swing.JCheckBox CBprofileLoaded;
    private VisualizationPanel PVizualization;
    private javax.swing.JRadioButton RBBlackAndWhite;
    private javax.swing.JRadioButton RBRgb;
    private javax.swing.JSlider SZoom;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private JPanel skalakolorow;
    // End of variables declaration
    
    
    private Profil profil;
    private Funkcja funkcja;
}
