import java.util.ArrayList;

public class Cards {

	public static ArrayList getAllCards()
	{
		ArrayList result = new ArrayList();
		int c, v;
		
		for (c=0; c<Card.colors.length; c++)
		{
			for (v=0; v<Card.values.length; v++)
			{
				result.add(new Card(c,v));
			}
		}
		return result;
	}	
	
	public static ArrayList getRandomCards(ArrayList source, int count)
	{
		ArrayList result = new ArrayList();
		
		while ((count > 0) && (source.size() > 0))
		{
			result.add(source.remove((int)(Math.random()*source.size())));
			count--;
		}
		
		return result;
	}
}
