#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>
#include <string.h>
#include <time.h>

#define BUFSIZE 1024 
#define DAYTIME 1304

int main(int argc, char* argv[])
{
    int sockfd = socket(AF_INET, SOCK_STREAM, 0);
    int connfd = 0;
    int counter = 0;

    struct sockaddr_in addr = {0};
    struct sockaddr_in* client;
    unsigned int client_size;

    char *buf;
    time_t czas;

    addr.sin_family = AF_INET;
    addr.sin_port = htons(DAYTIME);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);

    if (bind(sockfd, (struct sockaddr*)&addr, sizeof(addr)) == -1)
    {
      perror("bind");
      return 1;
    }

    if (listen(sockfd, 10) == -1)
    {
	perror("listen");
	return 1;
    }
    
    while (1)
    {
	connfd = accept(sockfd, (struct sockaddr*)client, &client_size);
	printf("%d connection!\n", counter);
	czas = time(NULL);
	buf = ctime(&czas);
	write(connfd, buf, strlen(buf));
	printf("%d bytes sent\n", strlen(buf));
	close(connfd);
	printf("connection closed\n");
	counter++;
    }

    close(sockfd);
    return 1;
}
