package src.logical;

public class Funkcja {
	
	/** okresla, czy zewnetrzna biblioteka zostala juz
	 * zaladowana, czy nie
	 */
	public boolean loaded = false;
	
	/**
	 * funkcja z zewnetrznej bibliteki, zwracajaca naprezenie
	 * dla punktu x,y
	 * @param x wspolrzedna
	 * @param y wspolrzedna
	 * @return wartosc naprezenia
	 */
	private static native double fval(double x, double y);
	
	/**
	 * @param p
	 */
	public Funkcja(Profil p){
		profil=p;
	}
	
	public boolean load(String fileName)
	{
		System.load(fileName);
		this.loaded = true;
		return this.loaded;
	}
	
	/**
	 * 
	 * @param d wspolrzedna
	 * @param e wspolrzedna
	 * @return zwraca wartosci z przedzialu od 1 do 1000 
	 * (-1 oznacza ze punkt poza figura)
	 */
	public float f(double d,double e){
		
		if (this.loaded  && profil.contains(d,e))
		{
			return (float)fval(d,e);
		}
		else
		{
			return -1;
		}
	}
	
	public void setProfil(Profil prof) {
		profil = prof;
	};
	
	Profil profil;
}
