package src.logical;

import java.awt.Polygon;
import java.awt.Rectangle;
import java.util.StringTokenizer;
import java.io.*;

public class Profil {
	private Polygon profile;
	public boolean loaded = false;
	
	public Profil()
	{
		profile = new Polygon();
		load("zz");
		loaded = true;
	}
	
	public boolean contains(double x, double y)
	{
		return profile.contains(x, y);
	}
	
	public boolean load(String fileName)
	{
    	String liniaWe;
    	int x, y;
    	StringTokenizer tokenizer;
    	
    	try {
    		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(fileName)));

    		while (in.ready()) 
    		{
    			liniaWe = in.readLine();
    			tokenizer = new StringTokenizer(liniaWe, " ");
				x = Integer.parseInt(tokenizer.nextToken());
				y = Integer.parseInt(tokenizer.nextToken());
				profile.addPoint(x, y);
			}
    	} catch (IOException e) {}
		return true;
	}
	
	public Rectangle getRectangle(){
		return profile.getBounds();
	}
}
