<%@ page language="java" contentType="text/html; charset=ISO-8859-2"
    pageEncoding="ISO-8859-2"%>
    <%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %> 
    <%@ taglib prefix="sql" uri="http://java.sun.com/jsp/jstl/sql" %>
    <%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
    
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-2">
<title>Pracownicy</title>
<style>
* {font-family: verdana; font-size: 10px; }
table {border: 2px solid gray; }
th {text-align: center; }
</style>
</head>
<body>
<fmt:setLocale value="pl_PL"/>
<sql:setDataSource var="db" dataSource="jdbc:oracle:thin:@dblab.cs.put.poznan.pl:1521:lab92,oracle.jdbc.driver.OracleDriver,inf66301,lit40abc" scope="application"/>

<sql:query dataSource="${db}" var="emp">
SELECT id_prac, nazwisko, nazwa, etat FROM pracownicy NATURAL JOIN zespoly
</sql:query>
<h1>Pracownicy</h1>

<table style="border: none">
<tr><td>
<table>
<tr>
	<c:forEach var="columnName" begin="1" items="${emp.columnNames}">
		<th><c:out value="${columnName}"/></th>
	</c:forEach>
	<th>&nbsp;</th>
</tr>

<c:forEach var="row" items="${emp.rowsByIndex}">
	<c:choose>
		<c:when test="${row[3] == 'DYREKTOR'}">
			<tr style="color: red">
		</c:when>
		<c:when test="${row[3] == 'PROFESOR'}">
			<tr style="color: orange">
		</c:when>
		<c:otherwise>
			<tr>
		</c:otherwise>
	</c:choose>
		<td><a href="
				<c:url value="./">
					<c:param name="id_prac" value="${row[0]}"/>
				</c:url>
			">
			<c:out value="${row[1]}"/>
			</a>
		</td>
		<td><c:out value="${row[2]}"/></td>
		<td><c:out value="${row[3]}"/></td>
	</tr>
</c:forEach>

</table>
</td>
<td style="vertical-align: top">
<c:if test="${!empty param.id_prac}">

	<sql:query dataSource="${db}" var="aemp">
	SELECT id_prac, nazwisko, etat, zatrudniony, placa_pod, placa_dod, nazwa, adres FROM pracownicy p LEFT OUTER JOIN zespoly z ON (p.id_zesp=z.id_zesp) WHERE id_prac = ?
		<sql:param value="${param.id_prac}"/>
	</sql:query>

	<c:forEach var="arow" items="${aemp.rowsByIndex}">
	<table>
		<tr><th>id_prac</th><td>${arow[0]}</td></tr>
		<tr><th>nazwisko</th><td>${arow[1]}</td></tr>
		<tr><th>etat</th><td>${arow[2]}</td></tr>
		<tr><th>zatrudniony</th><td>
			<fmt:formatDate value="${arow[3]}" type="date" dateStyle="FULL"/>
		</td></tr>
		<tr><th>placa_pod</th><td>
			<fmt:formatNumber value="${arow[4]}" type="currency"/>
		</td></tr>
		<tr><th>placa_dod</th><td>
			<fmt:formatNumber value="${arow[5]}" type="currency"/>
		</td></tr>
		<tr><th>nazwa</th><td>${arow[6]}</td></tr>
		<tr><th>adres</th><td>${arow[7]}</td></tr>		
	</table>
	<a href="<c:url value="./"/>">Ukryj</a>
	</c:forEach>

</c:if>

</td>
</tr>
</table>

</body>
</html>