
public class Card {
	public static final String[] colors = {"kier", "karo", "pik", "trefl"};
	public static final String[] values = {"2", "3", "4", "5", "6", "7", "8", "9", "10", "j", "q", "k", "as"};
	
	private int color;
	private int value;
	
	public String toString()
	{
		return values[value]+colors[color]; 
	}
	
	public Card(int color, int value)
	{
		this.color = color;
		this.value = value;
	}
	
	public int getValue()
	{
		return value;
	}
	
	public boolean equals(Object o)
	{
		return ((o != null) && (o instanceof Card) && (this.color == ((Card)o).color) && (this.value == ((Card)o).value));
	}
	
	public boolean equalsByValue(Object o)
	{
		return ((o != null) && (o instanceof Card) && (this.value == ((Card)o).value));
	}
}
