<?xml version="1.0" encoding="ISO-8859-2"?> 
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"> 

<xsl:template match="/">
	<html>
		<head>
			<title>Pracownicy</title>
			<style type="text/css">
			* {font-family: verdana, sans-serif;font-size: 10px}
			h1 {font-size: 14px;}
			h2 {font-size: 12px;}
			</style>
		</head>
		<body>
		<h1 style="color: red"><xsl:value-of select="INSTYTUT/NAZWA"/></h1>
		<address>
		<xsl:value-of select="INSTYTUT/ADRES"/><br/>
		<xsl:value-of select="INSTYTUT/KOD"/>
		</address>
		<h2>Lista pracownikw</h2>
		<table>
			<tbody>
				<tr>
					<th>id</th><th>nazwisko</th><th>etat</th><th>paca</th><th>zesp</th>
				</tr>
				<xsl:for-each select="INSTYTUT/ZESPOLY/ZESPOL/PRACOWNICY/PRACOWNIK">
						<xsl:sort select="NAZWISKO" />
						<xsl:choose>
						<xsl:when test="ETAT = 'DYREKTOR'">
							<tr style="background-color: rgb(255,255,128)">
								<td><xsl:value-of select="@ID"/></td>
								<td><xsl:value-of select="NAZWISKO"/></td>
								<td><xsl:value-of select="ETAT"/></td>
								<td><xsl:value-of select="PLACA"/></td>
								<td><xsl:value-of select="../../NAZWA"/></td>
							</tr>
						</xsl:when>
						<xsl:when test="ETAT = 'PROFESOR'">
							<tr style="background-color: rgb(128,255,255)">
								<td><xsl:value-of select="@ID"/></td>
								<td><xsl:value-of select="NAZWISKO"/></td>
								<td><xsl:value-of select="ETAT"/></td>
								<td><xsl:value-of select="PLACA"/></td>
								<td><xsl:value-of select="../../NAZWA"/></td>
							</tr>
						</xsl:when>
						<xsl:otherwise>
							<tr>
								<td><xsl:value-of select="@ID"/></td>
								<td><xsl:value-of select="NAZWISKO"/></td>
								<td><xsl:value-of select="ETAT"/></td>
								<td><xsl:value-of select="PLACA"/></td>
								<td><xsl:value-of select="../../NAZWA"/></td>
							</tr>
						</xsl:otherwise>
						</xsl:choose>
				</xsl:for-each>
			</tbody>
		</table>
		<h2>Podzia na zespoy</h2>
		<table>
			<tbody>
				<tr>
					<th>zesp</th><th>liczba</th>
					<xsl:for-each select="INSTYTUT/ZESPOLY/ZESPOL">
					<xsl:sort select="NAZWA" />
					<tr>
						<td><xsl:value-of select="NAZWA"/></td>
						<xsl:if test="count(PRACOWNICY/PRACOWNIK) = 0">
						<td>brak</td>
						</xsl:if>
						<xsl:if test="count(PRACOWNICY/PRACOWNIK) &gt; 0">
						<td><xsl:value-of select="count(PRACOWNICY/PRACOWNIK)"/></td>
						</xsl:if>
					</tr>
					</xsl:for-each>
				</tr>
			</tbody>
		</table>
		</body>
	</html>
</xsl:template>

</xsl:stylesheet>