#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>

#define BUFSIZE 1024 
#define DAYTIME 1304

int main(int argc, char* argv[])
{
    int sockfd = socket(AF_INET, SOCK_STREAM, 0);
    int cid;
    struct sockaddr_in addr = {0};
    char buf[BUFSIZE] = {0};

    if (argc < 2)
    {
	printf("usage: a.out ip_addr\n");
	return 1;
    }

    addr.sin_family = AF_INET;
    addr.sin_port = htons(DAYTIME);
    inet_pton(AF_INET, argv[1], &(addr.sin_addr)) ;

    cid = connect(sockfd, (struct sockaddr*)&addr, sizeof(addr));

    if (cid == -1)
    {
      perror("connect");
      return 1;
    }
    read(sockfd, buf, BUFSIZE);

    printf("%s", buf);

    close(cid);
    return 1;
}
