#!/bin/sh

lines=`wc -l $1 | cut -f 1 -d' '`
g=`basename ${1/.csv/}`
f=X${g/-/_}
cat <<EOF >eval.m
load $1
[beta,sigma] = ols ($f(1:$lines,2),$f(1:$lines,1));
printf("$g %f %f %f ops/unit\n", beta, sigma, (1+sigma)/beta);
EOF

octave --silent eval.m
rm eval.m

